#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

void kernel_cpu(int *A0,int *A1,int *A2,int *A3,int *A4,int *A5,int *A6,int *A7,int *A8,float *B0,float *B1,int N){
for(int i=0;i<N;i++){
A0[i] = A8[i];
A1[i] = A8[i];
A2[i] = A5[i]+A8[i]-A6[i];
A3[i] = A7[i]+A6[i]+A6[i];
B0[i] = B1[i]+B1[i]-B1[i];
}
}

int main(int argc,char **argv) {
int size=79894;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
int *A0;
A0 = (int *)malloc(intBytes);
int *A1;
A1 = (int *)malloc(intBytes);
int *A2;
A2 = (int *)malloc(intBytes);
int *A3;
A3 = (int *)malloc(intBytes);
int *A4;
A4 = (int *)malloc(intBytes);
int *A5;
A5 = (int *)malloc(intBytes);
int *A6;
A6 = (int *)malloc(intBytes);
int *A7;
A7 = (int *)malloc(intBytes);
int *A8;
A8 = (int *)malloc(intBytes);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
for(int i=0;i<79894;i++){
A0[i] = 57+i+1;
A1[i] = 36+i+1;
A2[i] = 43*i+1;
A3[i] = 77*i+1;
A4[i] = 7+i+1;
A5[i] = 20*i+1;
A6[i] = 25+i+1;
A7[i] = 56+i+1;
A8[i] = 52+i+1;
B0[i] = 82.1327966738*i+1;
B1[i] = 52.6845519951*i+1;
}
struct timeval time0,time1;
gettimeofday(&time0,NULL);
FILE *file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "1";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
kernel_cpu(A0,A1,A2,A3,A4,A5,A6,A7,A8,B0,B1,79894);
file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "0";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F); 
free(A0);
free(A1);
free(A2);
free(A3);
free(A4);
free(A5);
free(A6);
free(A7);
free(A8);
free(B0);
free(B1);
printf("\n");return 0; }